/* yasep/JScore/yasep_conditions.js
This file is distributed under terms of the Affero GPL v3 license or later, see http://yasep.org
created 2009-08-16 by whygee@f-cpu.org
version 2011-11-30 adding the BIT0/BIT1 conditions, cleanup the NPC stuff
version 2012-03-13 : fixing conditions
version 2012-03-15 : added EQ/NEQ

This is the list of the available conditions and the aliases.

the key string is the condition's name
the first number is the litteral value of the condition field.
2nd number is 1 if a register argument is expected
           or 2 if a number   argument is expected
3rd number is 1 when no example can be generated
  with this name because there are other alias choices.
*/

Y.tableConditionAll={
//  constant COND_ZERO : SLV2 := "00";
"ZERO"        :[0, 1, 0],
"ALWAYS"      :[0, 0, 1], // default in extended mode with no condition

"NZ"          :[1, 1, 0],
"NEVER"       :[1, 0, 0],

// Check a 16-bit field (source yet undertermined, R1 ?)
//  constant COND_BIT  : SLV2 := "01";
"BIT1"        :[2, 2, 0],
"BIT0"        :[3, 2, 0],

//  constant COND_LSB  : SLV2 := "10";
"LSB1"        :[4, 1, 0],
"ODD"         :[4, 1, 1], // alias
"CARRY"       :[4, 0, 0],
"NO_BORROW"   :[4, 0, 1], // alias

"LSB0"        :[5, 1, 0],
"EVEN"        :[5, 1, 1], // alias
"NO_CARRY"    :[5, 0, 0],
"BORROW"      :[5, 0, 1], // alias

//  constant COND_MSB  : SLV2 := "11";
"MSB1"        :[6, 1, 0],
"NEGATIVE"    :[6, 1, 1], // alias
"EQ"          :[6, 0, 0],

"MSB0"        :[7, 1, 0],
"POSITIVE"    :[7, 1, 1], // alias
"NEQ"          :[7, 0, 0]
};

Y.conditionTable=[]; // indexed by name, returns object

for (var i in Y.tableConditionAll) {
  if (Y.tableConditionAll[i][2]==0)
    Y.conditionTable.push(i);
}

Y.randomCondition=function(){
  var r,
  l=intrnd(Y.conditionTable.length), // number
  m=Y.conditionTable[l],    // return a name
  n=Y.tableConditionAll[m]; // return an array
  if (n[1]==1)
    return m+" "+Y.random_register("PC");
  if (n[1]==2)
    return m+" "+intrnd(16);
  return m;
}
