/*
yasep/doc/opcode_map.js
This file is distributed under terms of the Affero GPL v3 license or later, see http://yasep.org
 created on 2009-07-24 from  yasep/tools/opcode_map.html created by whygee at f-cpu.org
2006-09-06 : moved the form explanations to assembly.html
   (this also simplifies the handling of the anchors)
2007-04-11
2007-11-05 : rebranding to YASEP
2008-11-17
2009-01-06 : split the table into 2 parts
2009-01-18 : style changes
2009-01-23 : moved from /docs/ to /tools/
2009-07-11 : js_list2.js
2009-07-28 : Y
2009-08-09 integrated in a window, in yasep/tool/
2011-09-13 in ygwm, back in yasep/doc/, translated etc.
*/

init_obj.push(OpcodeTable={
  start: function(){

    OpcodeTable.cont=document.createElement("DIV");
    OpcodeTable.cont.innerHTML=import_htmi("doc/opcode_map");
    winman.patchInnerLinks(OpcodeTable.cont);
    var index, instr, t, h=getByClass("hiddenDiv","DIV",OpcodeTable.cont);
    OpcodeTable.win = ygwm.new_window(
       hiddenText(0,h), null, OpcodeTable.cont,
       850, Math.ceil((getHeight()*3)/4), 50, 50, false, true, true, true, false, "docStyle");

// OPCODE TABLE
    var m='<tr> <td colspan="2"></td> <td colspan="8" class="haut">'
      + hiddenText(1,h) + "</td> </tr> <td></td> <td></td>";

    for (var t=0; t<8; t++)
      m+=' <td class="haut">'+int2hex(t<<5,1,1)+"</td>\n";
    m+='</tr><tr><td class="haut" rowspan="16">'+hiddenText(2,h)+"</td>\n";

    for (var line=0; line<32; line+=4) { // group number

      m+='<td class="side">'+int2hex(line,1,1);
      if  (typeof Y.GroupNames[line]=="string")
        m+="<br>"+Y.GroupNames[line].replace(/GROUP_/,"");
      m+="</td>\n";

      for (var col=0; col<8; col++) {
        index=line|(col<<5);
        instr=Y.opcode_table[index];
        if (typeof instr == "object") {
          t=Y.decorate_opcode(index);
          m+="<td ";
          if (instr.flags & Y.Preliminary) {
            m+='style="background-color:#FA8" ';
          } else
            if (instr.flags & Y.OPTIONAL) {
              m+='style="background-color:#DDD" ';
            }
          m+='title="'+instr.description+'" id="'+instr.name+'"><a name="'+instr.name+'">'
           +t+' <span style="float:right">'+int2hex(index,1,1)+"</span><br>"+Y.form2html(instr.forms,1)
           +"<br>"+Y.flags2html(instr.flags)+'</a>'+"</td>\n";
        }
        else
          m+='<td>'+"</td>\n";
      }
      m+="</tr>"+'<tr>\n';
    }
    document.getElementById("optab_ISM").innerHTML=m;


// ALIASES
    m="<tr><td>Alias</td><td>"+hiddenText(3,h)+"</td><td>"+hiddenText(4,h)+"</td></tr>";
    var j=0;
    for (var i in Y.opcode_aliases) {
      m+="<tr";
      if (j^=1)
        m+=' bgcolor="#EEEEFF"';
      m+=">"+'<td class="f">'+Y.decorate_opcode(i)+"</td>"
       +'<td class="f">'+Y.form2html(Y.table_opcode[i].forms)+"</td>"
       +'<td class="f">'+Y.decorate_opcode(Y.opcode_aliases[i])+"</td>"
       +'</tr>\n';
    }
    document.getElementById("optab_aliases").innerHTML=m;


/// FORMS
    m="<tr><td>"+hiddenText(5,h)+"</td><td>"+hiddenText(6,h)+"</td><td>Opcodes</td></tr>";

    // gathering the stats :
    var i;
    var FormUsage=[];
    var FlagUsage=[];
    for (i=1; i<Y.MAX_FORM; i+=i)
      FormUsage[i]=[];
    for (i=1; i<Y.MAX_FLAG; i+=i)
      FlagUsage[i]=[];

    // scan the list of opcodes
    for (var name in Y.table_opcode) {
      if (Y.table_opcode[name].forms>0) {
        instr=Y.table_opcode[name];
        t=Y.decorate_opcode(name)+" ";
        i=1;
        while (i<=instr.forms) {
          if (i & instr.forms)
            FormUsage[i][FormUsage[i].length]=t;
          i+=i;
        }
        i=1;
        while (i<=instr.flags) {
          if (i & instr.flags)
            FlagUsage[i][FlagUsage[i].length]=t;
          i+=i;
        }
      }
    }
    var j=0;
    for (var i in Y.TableForm) {
      m+=("<tr");
      if (j^=1)
        m+=' bgcolor="#EEEEFF"';
      var t=Y.TableForm[i];
      m+=">"+'<td class="f">'+"<a href=\"#!doc/forms#"+t
       +'" class="innerLink" onclick="wa(\'doc/forms#'+t+'\')">'+t+"</a></td>"
       +'<td class="f">'+FormUsage[i].length+"</td>"
       +'<td class="f">\n'+FormUsage[i].sort().join(" ")+"</td></tr>\n";
    }
    document.getElementById("optab_forms").innerHTML=m;


// FLAGS
    m="<tr><td>Flag</td><td>"+hiddenText(6,h)+"</td><td>Opcodes</td></tr>";
    j=0;
    for (var i in Y.TableFlags) {
      m+="<tr";
      if (j^=1)
        m+=' bgcolor="#EEEEFF"';
      var t=Y.TableFlags[i];
      m+=">"+'<td class="f">'+"<a class=\"innerLink\" onclick=\"wa('doc/flags#"+t
       +'\')" href="#!doc/flags#'+t+'">'+t+"</a></td>"
       +'<td class="f">'+FlagUsage[i].length+"</td>"
       +'<td class="f">'+"\n"+FlagUsage[i].sort().join(" ")+"</td></tr>\n";
    }
    document.getElementById("optab_flags").innerHTML=m;

    return OpcodeTable.win;
  },

  init_obj: function() {
    test_opcodes.menuItem = menu.subMenuItem(menu.mainMenuItem("Doc"),"Opcode&nbsp;table", "doc/opcodes");
  }
}); // OpcodeTable
